
/*
 * $Id: Tuner.cc,v 1.2 1999/04/15 20:35:54 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "Tuner.h"

Tuner::Tuner(): theSensy(-1), theReact(-1), 
	theTarget(0), theInput(0), theOutput(0),
	theWin(-1), theCnt(0), theAcc(0) {
}

void Tuner::target(double aTarget) {
	// start from the very beginning
	theTarget = theInput = theOutput = aTarget;
	theAcc = theCnt = 0;
}

void Tuner::syncInput(double or) {
	Assert(theWin >= 0 && theSensy >= 0 && theReact >= 0); // must be set

	theOutput *= 1 - theSensy;
	theOutput += theSensy*or;

	theInput += (theTarget - theOutput)*theReact;

	theAcc = theCnt = 0; // reset
}
