
/*
 * $Id: Client.h,v 1.15 1999/04/15 20:36:04 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef CLIENT_CLASS_H
#define CLIENT_CLASS_H

#include "AlarmClock.h"
#include "CltXact.h"
#include "CltConnMgr.h"

class Connection;
class RndDistr;

class Client: public CltConnMgr::User, public AlarmUser {
	public:
		Client();
		virtual ~Client();

		virtual void start();

		virtual void noteXactDone(CltXact *x);
		virtual void noteConnReady(Connection *conn);

	protected:
		void configure(CltConnMgr *aConnMgr, int ccLevel, RndDistr *aThinkDistr);
		void scheduleLaunch(Time lastLaunch);
		void launch();

	protected:
		ObjFarm<CltXact> theXacts;
		CltConnMgr *theConnMgr;
		RndDistr *theThinkDistr;

		int theLaunchCount; // number of xaction launches
};

#endif
