
/*
 * $Id: BigSize.h,v 1.2 1999/05/24 00:52:32 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef XSTD_BIG_SIZE_H
#define XSTD_BIG_SIZE_H

// BigSize can accommodate values up to 4611686016279904256 bytes
// for 4 byte integers, which is approximately 4 exabytes
// usually used for Size "accumulators"
class BigSize {
	public:
		static BigSize MB(int mb);

	public:
		BigSize();

		operator void*() const { return theAcc || theCnt ? (void*)-1 : 0; }
		BigSize &operator +=(const BigSize &sz);
		BigSize &operator +=(int sz);
		double operator /=(const BigSize &sz) const;

		// total number of bytes converted to double
		double byted() const;

	protected:
		int theAcc; // accumulates values in MAX_INT chunks (~2GB)
		int theCnt; // counts chunks
};

inline
BigSize operator +(BigSize sz1, BigSize sz2) { return sz1 += sz2; }

inline
double operator /(BigSize sz1, BigSize sz2) { return sz1 /= sz2; }

#endif
